<template lang="pug">
q-select.rounded-borders.ui-input-autocomplete(
	outlined
	v-model="model"
	use-input
	dense
	fill-input
	:lazy-rules="true"
	input-debounce="300"
	:label="label"
	:options="options"
	@filter="onSearch"
	:clearable="!required"
	:multiple="multiple"
	:required="undefined"
	:option-label="item => item.name"
	hide-bottom-space
	:rules="getRules"
)
	template(#selected-item="props")
		slot(name="selected-item" :props="props")

	template(#no-option="props")
		slot(name="no-option" :props="props")
			q-item
				q-item-section.text-grey Ничего не найдено

</template>

<script lang="ts" setup>
	import { defineProps, computed, defineEmits, ref } from 'vue'
	const props = defineProps({
		modelValue: {},
		type: {
			type: String,
			default: 'text',
		},
		label: {
			type: String,
			default: '',
		},
		required: {
			type: Boolean,
			default: false,
		},
		multiple: {
			type: Boolean,
			default: false,
		},
		rules: {
			type: Array,
			default: () => [],
		},
		options: {
			type: Array,
			default: () => [],
		},
	})
	const getRules = computed(() => {
		const hasValue = props.required
			? [
					(val: any) =>
						Array.isArray(val)
							? val.length > 0
							: val !== '' || `Необходимо указать ${props.label.toLowerCase()}`,
			  ]
			: []
		const moreThenZero =
			props.required && props.type === 'number'
				? [(val: number) => val > 0 || `Значение ${props.label.toLowerCase()} должно быть больше нуля`]
				: []
		return props.rules.length || props.required ? [...hasValue, ...moreThenZero, ...props.rules] : undefined
	})
	const emit = defineEmits(['update:modelValue', 'onSearch'])
	const model = computed({
		get() {
			return props.modelValue
		},
		set(value) {
			emit('update:modelValue', value)
		},
	})
	const onSearch = (search: string, update: any) => {
		emit('onSearch', search, update)
	}
</script>

<style lang="scss" scoped>
	.ui-input-autocomplete {
		&.q-field--focused,
		&.q-field--float {
			&:deep(.q-field__label) {
				transform: translateY(-85%) scale(0.75) !important;
				z-index: 1;
				background: $main-background;
				padding: 0 5px;
				margin-left: -5px;
				right: auto;
				max-width: calc(135% + 10px);
			}
		}

		&:deep(.q-field__control-container) {
			padding-top: 0 !important;
		}

		&:deep(.q-chip) {
			overflow: hidden;
			.q-avatar {
				&__content {
					background: #fff;
					img {
						width: auto;
						height: auto;
						max-width: 100%;
						max-height: 100%;
					}
				}
			}
			span {
				color: $dark !important;
			}
		}
	}
</style>
